#include "Tlc5940.h"  //import the tlc library
#include "tlc_servos.h" //Import the servo library for the tlc.
#include <Wire.h>


#include "WProgram.h"
void setup();
void loop();
void receiveEvent(int howmany);
void sleep();
void blinkeyes();
void saveeyes();
void fullmouthvolume();
void checkforsubandpassrest();
void clearserial();
void checkvolumewhile();
void behappy();
void setservos();
void bemad();
void besad();
void linemouth();
void fullmouth();
void offmouth();
void offeyes();
void bluegreeneyes();
void redeyes();
void blueeyes();
void openmouth();
void resetmouth();
void reseteyes();
void talkmouth();
void updatetlc();
int servoL = 0; // servo position varibles
int servoR = 0; 

int lightpwms[42]; // a array that will hold all of the pwm values of the leds for the mouth and the eyes. values are 0-4095. 0 is off. 4095 is full on.
int eyes[6]; //array to hold pwms of the eyes for the saveeyes subroutine.

#define SERVO_CHANNELL   43 //Define servo pin in library.
#define SERVO_CHANNELR   44 // define servo pin in library.

char serial[20]; //word string from serial.
char transitchar; //1 character from serial.
int i = 0;

int firstnumber = 0;
int secondnumber = 0;
int power = 0;
int lednumber = 0;
int volume;
int volumesample = 0;
int ledvolume = 0;
int whiletimes = 0;
int talking = 1;
int arraysum = 0;
long previousMillis = 0;
long blinkinterval = 0;



void setup() {
  
//pinMode(switchpin, INPUT); //set the switchpin as input
//pinMode(terminatebutton, INPUT); //set the pin as input
Serial.begin(9600);	// opens serial port, sets data rate to 9600 bps
Tlc.init(); // init the tlc's
tlc_initServos();  // Note: this will drop the PWM freqency down to 50Hz.
delay(20);//wait a bit before proceding
behappy(); //be happy!!1
linemouth(); //It needs a mouth!
Serial.println("Ready");
Wire.begin(2);                // join i2c bus with address #2
Wire.onReceive(receiveEvent); // register event
blinkinterval = random(2000, 11000);
  

} //end of setup



void loop(){

checkforsubandpassrest(); //check the current word for a subroutine command and ignore all else.

checkvolumewhile(); //check if there is stuff coming out of the waveshield.
   if (volume >= 75) {
     //if volume input is more than line noise. (This will have to be adjusted to your specific waveshield, also tweak the subroutine "checkvolumewhile()")
     fullmouthvolume();
     talking = 1;
   } else if (volume < 75 && talking == 1) {
    linemouth(); 
    talking = 0;
   } 
   
   if (millis() - previousMillis > blinkinterval) {
   blinkeyes();
   }
} //end main loop

//events!!!!

void receiveEvent(int howmany) { //no subroutines plz! and the gnd and 5v have to be connected.
while (Wire.available() > 0) { //Get the word!
   transitchar = Wire.receive(); //get char
   if (transitchar != ';') { //if char not equal ;
    serial[i] = transitchar;  //then put in the char to string
    i++;
   } //end of if
 }//end of while 
} //end of event

//Subroutines!!!

void sleep() {
  //if addition of the array is not zero then repeat
  arraysum = 0;
  for (int i = 0; i < 42; i++) {
  arraysum = arraysum + lightpwms[i];
  }
  while (arraysum > 0) {
   for (int i = 0; i < 42; i++) {
  //minus one to all leds
  if (lightpwms[i] > 0) {
    lightpwms[i] = lightpwms[i] - 1;
  }
   }
   updatetlc();
  delay(5);
  arraysum = 0;
  for (int i = 0; i < 42; i++) {
  arraysum = arraysum + lightpwms[i];
  }
  } //while
  
  //while (1==1) {
    
  //}
}

void blinkeyes() { //blink the eyes at intervals of 2-11 seconds.
  saveeyes();
  offeyes();
  delay(9);
 for (int i = 36; i < 42; i++){
  lightpwms[i] = eyes[i-36];
}
updatetlc();
delay(5);
offeyes();
delay(9);
for (int i = 36; i < 42; i++){
  lightpwms[i] = eyes[i-36];
}

updatetlc();
blinkinterval = random(2000, 11000);
previousMillis = millis();
}

void saveeyes() {
 for (int i = 36; i < 42; i++){
  eyes[i-36] = lightpwms[i];
}
}

void fullmouthvolume() {
  resetmouth();
  ledvolume = volume * 5;
  for (int i = 0; i <= 35; i++) { // light up all the leds in the mouth to analog input.
    lightpwms[i] = ledvolume; 
  } 
  updatetlc(); //update
} //end of fullmouthvolume


void checkforsubandpassrest() {
  Serial.print(serial);
  if (strcmp(serial, "behappy")  == 0) { //check if the word is
       behappy();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "setservos")  == 0) { //check if the word is
       setservos();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "bemad")  == 0) { //check if the word is
       bemad();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "besad")  == 0) { //check if the word is
       besad();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "linemouth")  == 0) { //check if the word is
       linemouth();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "fullmouth")  == 0) { //check if the word is
       fullmouth();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "offmouth")  == 0) { //check if the word is
       offmouth();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "offeyes")  == 0) { //check if the word is
       offeyes();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "bluegreeneyes")  == 0) { //check if the word is
       bluegreeneyes();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "redeyes")  == 0) { //check if the word is
       redeyes();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "blueeyes")  == 0) { //check if the word is
       blueeyes();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "openmouth")  == 0) { //check if the word is
       openmouth();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "talkmouth")  == 0) { //check if the word is
       talkmouth();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "setleds")  == 0) { //check if the word is
       //setleds();
      clearserial(); //clear serial
      i = 0; //reset
      } else if (strcmp(serial, "sleep")  == 0) { //check if the word is
       //setleds();
       sleep();
      i = 0; //reset
      } else {
       //Serial.print(serial); 
       //Serial.print(' ');
       clearserial();
       i = 0;
      }
  
}

void clearserial() {
for (int i = 0; i < 20; i++) {
serial[i] = '\0';
}  
}

void checkvolumewhile() {
     volume = 0; //reset.
     whiletimes = 0;
     while (whiletimes <= 30) { //for some odd reason, when i used a for loop, it didn't receive information
     volumesample = analogRead(1) - 512; //512 is about the line voltage of the waveshield when it is not outputing.
     if (volumesample < 0) //if the volume is negative then make it un-negative. (Sound is a wave)
        volumesample *= -1;
     if (volumesample > volume) //if the sampled volume is more than the previous sampling then use this one.
       volume = volumesample; 
       whiletimes++;
     } //end of while
     Serial.println(volume); //usefull for figuring out what is the exact line voltage of the waveshield.
} //end of sub



void behappy() { //be happy!
  servoR = 75; //servo position
  servoL = 75;
  setservos(); //this takes care of the stuff that the lines below used to do. The magic of Subroutines!
  //tlc_setServo(SERVO_CHANNELR, servoR); //set the servos
  //tlc_setServo(SERVO_CHANNELL, servoL);
  //updatetlc(); //update
  //delay(10); //you need a delay after the update
  bluegreeneyes();
  } //end behappy
  
void setservos() { //subing it up
  tlc_setServo(SERVO_CHANNELR, servoR); //set the servos
  tlc_setServo(SERVO_CHANNELL, servoL);
  updatetlc(); //update
} //end sub
  
void bemad() {
  servoR = 130;
  servoL = 130;
  setservos();
  redeyes();
}

void besad() {
 servoR = 30;
 servoL = 30;
 setservos();
 blueeyes();
}
  

void linemouth() {
// make a line mouth..
resetmouth();
for (int i = 0; i < 18; i++){
lightpwms[i + 9] = 4095;
}
updatetlc(); //update
} //end linemouth


void fullmouth() {
  resetmouth();
  for (int i = 0; i <= 35; i++) { // light up all the leds in the mouth to low.
    lightpwms[i] = 100; 
  }
  lightpwms[7] = 1500; // compensate for some burned leds.
  lightpwms[8] = 1000;
  lightpwms[27] = 1500; 
  updatetlc(); //update
} //end fullmouth


void offmouth() { // turns off the mouth leds.
 resetmouth(); //reset mouth.
 updatetlc();  //update.
} //end offmouth


void offeyes() { // turns off the eye leds.
 reseteyes();  //reset eyes.
 updatetlc();  //update.
} //end offeyes


void bluegreeneyes() { //bluegreeneyes
  reseteyes();
  lightpwms[38] = 4095; //eyes. this will achieve a blue-green color w/ full intensity.
  lightpwms[39] = 4095; //eyes
  lightpwms[40] = 4095; //eyes
  lightpwms[41] = 4095; //eyes
  //lightpwms[42] = 4095; //eyes 
  updatetlc(); //update
} //end bluegreeneyes

void redeyes() {
 reseteyes();
 lightpwms[36] = 4095;
 lightpwms[37] = 4095;
 updatetlc();
}

void blueeyes() {
 reseteyes();
 lightpwms[38] = 4095;
 lightpwms[39] = 4095;
 updatetlc();
}


void openmouth() {
  resetmouth();
  for (int i = 0; i < 9; i++) { // light up the top row.
    lightpwms[i] = 4095; 
  }
  for (int j = 27; j < 36; j++) { // light up the bottom row.
    lightpwms[j] = 4095;
   }
  updatetlc(); //update
  delay(10);
} //end openmouth


void resetmouth() { // reset the array for the mouth leds. does NOT update! use offmouth() to turn off mouth leds.
  for (int i = 0; i < 36; i++) { // erase!!
    lightpwms[i] = 0;
   } 
} //end resetmouth


void reseteyes() { // reset the array for the eye leds. does NOT update! use offeyes() to turn off eye leds.
  for (int i = 36; i < 42; i++) { // erase!!
    lightpwms[i] = 0;
   }
} //end reseteyes


void talkmouth() { //finished and debugged. will make a talking mouth.
  linemouth();
  for (int i = 0; i <= 3; i++){ // FINISHED!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! FUCK YEAH!!!!!!
  openmouth();
  delay(400);
  linemouth();
  delay(400);
  } //end for loop
} //end talkmouth


void updatetlc() { //subroutine to update all leds.
 for (int j = 0; j < 42; j++) {
    Tlc.set(j, lightpwms[j]);
    }
 Tlc.update();
 delay(50); 
} //end updatetlc


int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

